this.name					= "aquatics_equipment";
this.author					= "Thargoid";
this.copyright				= "Creative Commons: attribution, non-commercial, sharealike with clauses - see readme.txt";
this.description			= "Controls equipment availablity in Aquatics.";
this.version				= "2.31";
"use strict";

this.startUp = function()
	{
	if(!missionVariables.aquatics_timer && missionVariables.aquatics_reputation && missionVariables.aquatics_reputation > 0)
		{
		missionVariables.aquatics_timer = clock.days;
		}
	}

this.shipExitedWitchspace = function()
	{
	if(!missionVariables.aquatics_timer)
		{
		return;
		}

	if((clock.days - missionVariables.aquatics_timer > 50) && (missionVariables.aquatics_reputation == 1) )
		{
		missionVariables.aquatics_reputation = 2;
		}

	if((clock.days - missionVariables.aquatics_timer > 150) && (missionVariables.aquatics_reputation == 0) )
		{
		missionVariables.aquatics_reputation = 2;
		}

	if(missionVariables.aquatics_reputation == 2)
		{
		delete this.shipExitedWitchspace;
		}
	}

this.shipWillDockWithStation = this.shipWillEnterWitchspace = function()
	{
	missionVariables.aquatics_guardianActive = null;
	var guardian = system.shipsWithRole("aquatics_guardianPlayer") 
	for (var i = 0; i < guardian.length; i++) 
		{ 
		guardian[i].remove() 
		missionVariables.aquatics_guardianCount += 1; 
		}

	}

this.alertConditionChanged = function()
	{
	if(player.ship.equipmentStatus("EQ_AQUATICS_GUARDIAN") == "EQUIPMENT_UNAVAILABLE" && player.ship.equipmentStatus("EQ_AQUATICS_1_GUARDIAN") == "EQUIPMENT_UNAVAILABLE") // if system is not installed
		{
		return;
		}

	if(missionVariables.aquatics_guardianActive && player.alertCondition < 3) // if alert = yellow/green and Guardians are deployed
		{
		player.consoleMessage("Guardian System Deactivated", 2);
		this.shipWillDockWithStation(); // perform same code as when docking, to remove the guardians
		return;
		}

	if(player.alertCondition == 3 && player.alertHostiles && !missionVariables.aquatics_guardianActive) // if red alert by hostiles and the Guardians aren't deployed
		{
		if(missionVariables.aquatics_guardianCount > 0)
			{
			for(var i=0; i < missionVariables.aquatics_guardianCount; i++)
				{
				player.ship.ejectItem("aquatics_guardianPlayer");
				}
			player.consoleMessage("Guardian System Activated", 2);
			missionVariables.aquatics_guardianCount = 0;
			missionVariables.aquatics_guardianActive = true;
			return;
			}
		else
			{
			if(player.ship.equipmentStatus("EQ_AQUATICS_GUARDIAN") == "EQUIPMENT_OK")
				{
				player.ship.setEquipmentStatus("EQ_AQUATICS_GUARDIAN", "EQUIPMENT_DAMAGED");
				return;
				}
			else
				{
				player.ship.setEquipmentStatus("EQ_AQUATICS_1_GUARDIAN", "EQUIPMENT_DAMAGED");
				return;
				}

			}
		}
	
	}

this.playerBoughtEquipment = function(equipment)
	{
	switch(equipment)
		{
		case "EQ_AQUATICS_GUARDIAN":
		case "EQ_AQUATICS_1_GUARDIAN":
			{
			missionVariables.aquatics_guardianCount = 2;
			missionVariables.aquatics_guardianActive = null;
			break;
			}

		case "EQ_AQUATICS_CLOAK":
			{
			player.ship.removeEquipment("EQ_AQUATICS_CLOAK");
			player.ship.awardEquipment("EQ_CLOAKING_DEVICE");
			if(EquipmentInfo.infoForKey("EQ_CLOAKING_DEVICE").effectiveTechLevel === 99)
				{EquipmentInfo.infoForKey("EQ_CLOAKING_DEVICE").effectiveTechLevel = 14;} // make cloak repairable at tech 14 (in-game 15).
			break;
			}
		}
	}

this.equipmentDamaged = this.equipmentDestroyed = function(equipment)
	{
	if(equipment == "EQ_AQUATICS_GUARDIAN" || equipment == "EQ_AQUATICS_1_GUARDIAN")
		{
		player.consoleMessage("Guardian System Offline", 3);
		this.shipWillDockWithStation(); 
		missionVariables.aquatics_guardianCount = 0;
		}
	}