this.name					= "aquatics_guardianPlayer";
this.author					= "Thargoid";
this.copyright				= "Creative Commons: attribution, non-commercial, sharealike with clauses - see readme.txt";
this.description			= "AI-actions script for the guardian drones for the player ship";
this.version				= "2.31";
"use strict";

this.locatePlayer = function()
	{
	this.playerArray = system.shipsWithPrimaryRole("player");
	if(this.playerArray.length == 0) // where'd they go?
		{
		missionVariables.aquatics_guardianActive = "false"; 
		this.ship.remove(); // If no player, then we can remove the drone.
		}
	else
		{
		this.ship.target = this.playerArray[0];
		this.ship.reactToAIMessage("PLAYER_FOUND");
		}
	}

this.checkPlayerSpeed = function()
	{
	if(player.ship.speed < 1000)
		{ this.ship.reactToAIMessage("PLAYER_SUBSONIC"); }
	else
		{ this.ship.reactToAIMessage("PLAYER_SUPERSONIC"); }
	}

this.findPlayerHostiles = function()
	{
	function isHostileToPlayer(entity) 
		{ 
		return (entity.isThargoid || (entity.isShip && entity.target && entity.target == player.ship && entity.hasHostileTarget));
		}
	if(this.ship.target == player.ship && player.ship.target && player.ship.target.bounty > 10)
		{
		this.ship.target = player.ship.target;
		this.ship.reactToAIMessage("HOSTILE_FOUND");
		}
	else
		{
		var targets = system.filteredEntities(this, isHostileToPlayer, this.ship, this.ship.scannerRange);
		if(targets.length > 0)
			{
			this.ship.target = targets[0];
			this.ship.reactToAIMessage("HOSTILE_FOUND");
			}
		else
			{ this.ship.reactToAIMessage("NO_HOSTILE_FOUND"); }
		}
	}

this.fireCheck = function()
	{
	if(this.ship.target && (this.ship.target.hasRole("aquatics_guardianPlayer") || this.ship.target.isPlayer))
		{ this.ship.reactToAIMessage("FRIENDLY_FIRE"); }
	else
		{ this.ship.reactToAIMessage("ENEMY_FIRE"); }
	}

this.shipTargetDestroyed = function(target)
	{
	if(target.primaryRole == "constrictor" && missionVariables.conhunt && missionVariables.conhunt == "STAGE_1")
		{ missionVariables.conhunt = "CONSTRICTOR_DESTROYED"; } // just in case an escort kills the constrictor, let's not break the mission for the player...
		
	if(target.isRock || target.isBoulder || target.isCargo || target.isDerelict || target.isWeapon)
		{ return; }
	
	player.score += 1;
	player.credits += target.bounty;
	player.consoleMessage("Guardian kill - " + target.name + " : " + target.bounty + "₢ awarded.", 5);
	log("Guardian kill - " + target.name + " : " + target.bounty);
	}	

this.shipDied = function(whom,why)
	{
	if(missionVariables.aquatics_guardianActive == "true") // if the drone was killed whilst in-flight
		{ player.consoleMessage("Guardian drone lost.", 3); }
	}