this.name					= "aquatics_hammerHead";
this.author					= "Thargoid";
this.copyright				= "Creative Commons: attribution, non-commercial, sharealike with clauses - see readme.txt";
this.description			= "Aquatics Hammerhead script.";
this.version				= "2.31";
"use strict";

this.shipSpawned = function()
	{
	this.nameShip();
	this.randomiseCargo();
	if(Math.random() > 0.75)
		{ this.ship.switchAI("aquatics_haulerWitchAI.plist"); }
	}

this.nameShip = function()
	{
	this.shipTitle = expandDescription('[aquatics_haulerName]');
	if(Math.random() > 0.25)
		{ this.shipTitle = this.shipTitle + expandDescription('[aquatics_haulerNumber]'); }

	if(this.shipTitle === "Kraken IV") // that name is reserved for the special mission ship
		{ this.nameShip(); }

	this.ship.displayName = "AHC " + this.shipTitle;
	}

this.randomiseCargo = function()
	{
	if(Math.random() < (Math.random() / 3) && this.ship.subEntities && this.ship.subEntities.length > 2)
		{
		this.ship.subEntities[0].remove();
		this.randomiseCargo();
		}
	}

this.beginUnload = function()
	{ this.ship.commsMessage("WARNING - This is the HammerHead class hauler AHC " + this.shipTitle + ". Please exercise caution around this region as we are beginning our unloading process."); }

this.endUnload = function()
	{ this.ship.commsMessage("This is the AHC " + this.shipTitle + ". Our unloading for " + system.name + " is now completed."); }

this.chooseDestination = function() // if we've got some cargo sleds left, go to witchpoint and jump somewhere else, if not sunskim to get rid of hauler.
	{
	if(this.ship.subEntities && this.ship.subEntities.length > 0)
		{ this.ship.switchAI("aquatics_haulerWitchAI.plist"); }
	else
		{ this.ship.switchAI("route2sunskimAI.plist"); }
	}

this.launchSled = function()
	{
	if(this.ship.subEntities && this.ship.subEntities.length > 0)
		{
		if(Math.random() > 0.5)
			{
			this.subPosition = this.ship.subEntities[0].position;
			this.subOrientation = this.ship.subEntities[0].orientation;
			this.ship.subEntities[0].remove();
			let subSled = this.ship.spawnOne("aquatics_cargoSled"); 
			subSled.position = this.localToGlobal(this.subPosition); 
			subSled.orientation = this.subOrientation.multiply(this.ship.orientation); 
			subSled.switchAI("aquatics_launchAI.plist"); 
			if(Math.random() < 0.1) // 1 in 20 chance per sled launch that hauler stops unloading and take some sleds away with it.
				{
				this.endUnload();
				this.ship.AIState = "IDLE";
				}	
			}
		}
	else
		{
		this.endUnload();
		this.ship.AIState = "IDLE"; // if we unload everything, then no need to come back here and we can prepare to leave.
		}
	}

this.localToGlobal = function(position)
	{ // sub-ent position is relative to mother, but for swapping we need the absolute global position
	let orientation = this.ship.orientation;
	return this.ship.position.add(position.rotateBy(orientation));
	}

this.shipDied = function(who,why)
	{
	this.largeCount = (Math.ceil(Math.random() * 4) - 1); // between 0-3 large pieces of wreckage
	this.smallCount = (Math.ceil(Math.random() * 9) - 1); // between 0-8 small pieces of wreckage
	this.fuelCount = (Math.ceil(Math.random() * 30) + 30); // between 31-40 burning fuel entities

	this.ship.spawn("aquatics_burningFuel", this.fuelCount); // spawn the burning fuel

	if(Math.random() > 0.33) //  2 in 3 chance of a piece of non-exploding wreckage
		{ this.ship.spawn("aquatics_survivingWreckage", 1); } // spawn the surviving piece of wreckage

	if(this.largeCount > 0) // if there is large wreckage
		{ this.ship.spawn("aquatics_largeWreckage", this.largeCount); } // spawn the large pieces of exploding wreckage

	if(this.smallCount > 0) // if there is small wreckage
		{ this.ship.spawn("aquatics_smallWreckage", this.smallCount); } // spawn the small pieces of exploding wreckage
	}