this.name					= "aquatics_kraken";
this.author					= "Thargoid";
this.copyright				= "Creative Commons: attribution, non-commercial, sharealike with clauses - see readme.txt";
this.description			= "Script for mission of stolen Kraken IV hauler.";
this.version				= "2.31";
"use strict";

function aquatics_localMines(entity) { 
	var isWeapon = entity.isWeapon, 
		isActive = entity.AI !== "aquatics_deactivatedAI.plist", 
		mines = ["EQ_QC_MINE", "EQ_RMB_CASCADE_MISSILE", "EQ_RMB_LAW_MISSILE", "EQ_RMB_OVERRIDE_MISSILE", 
			"energy-bomb", "EQ_NUKE2_MISSILE", "EQ_HARPOON_NUKE2_MISSILE", "EQ_PHOTON_MISSILE", "RANDOM_HITS_MINE"], 
		isLocalMine = mines.some(function (element, i, array) {return entity.hasRole(element);}); 
	return isWeapon && isActive && isLocalMine; 
	} 

this.shipSpawned = function()
	{
	if(this.scanTimer)
		{ this.scanTimer.start(); }
	else
		{ this.scanTimer = new Timer(this, this.mineScan, 0, 4.75); }
	}	
	
this.mineScan = function()
	{
	this.mineArray = system.filteredEntities(this, aquatics_localMines, this.ship, 25600);
	
	if(this.mineArray.length > 0)
		{
		player.consoleMessage("Cascade suppression field detected", 6);
		this.mineArray.forEach(function (mine) 
			{
			mine.setAI("aquatics_deactivatedAI.plist"); 
			mine.displayName = "Disarmed " + mine.displayName;
			mine.scannerDisplayColor1 = "whiteColor";
			mine.scannerDisplayColor2 = "whiteColor";
			}
			)
		}
	}
	
this.findTargets = function()
	{
	function isHostileTarget(entity) 
		{ 
		return (entity.isShip && (entity.isPlayer || entity.isPolice || entity.isThargoid));
		}
	var targets = system.filteredEntities(this, isHostileTarget, this.ship, 25600);
	if(targets.length > 0)
		{
		this.ship.target = targets[0];
		this.ship.reactToAIMessage("TARGET_FOUND");
		}
	else
		{
		this.ship.reactToAIMessage("NOTHING_FOUND");
		}
	}

this.shipExitedWitchspace = this.leftSystem = function()
	{
	missionVariables.aquatics_krakenMission = "FAILED";
	mission.setInstructionsKey("aquatics_krakenShortFailure", "aquatics_populator");
	this.ship.switchAI("sunSkimExitAI.plist");
	}

this.shipDied = function(who,why)
	{
	if(missionVariables.aquatics_krakenMission == "BEGUN") // if the ship was killed whilst the mission was active - success
		{
		missionVariables.aquatics_krakenMission = "SUCCEEDED";
		mission.setInstructionsKey("aquatics_krakenShortSuccess", "aquatics_populator");
		}

	this.largeCount = (Math.ceil(Math.random() * 6) - 1); // between 0-5 large pieces of wreckage
	this.smallCount = (Math.ceil(Math.random() * 16) - 1); // between 0-15 small pieces of wreckage
	this.fuelCount = (Math.ceil(Math.random() * 30) + 30); // between 31-60 burning fuel entities

	this.ship.spawn("aquatics_burningFuel", this.fuelCount); // spawn the burning fuel

	if(Math.random() > 0.33) //  2 in 3 chance of a piece of non-exploding wreckage
		{ this.ship.spawn("aquatics_survivingWreckage", 1); } // spawn the surviving piece of wreckage

	if(this.largeCount > 0) // if there is large wreckage
		{ this.ship.spawn("aquatics_largeWreckage", this.largeCount); } // spawn the large pieces of exploding wreckage

	if(this.smallCount > 0) // if there is small wreckage
		{ this.ship.spawn("aquatics_smallWreckage", this.smallCount); } // spawn the small pieces of exploding wreckage
	}