this.name					= "aquatics_platform";
this.author					= "Thargoid";
this.copyright				= "Creative Commons: attribution, non-commercial, sharealike with clauses - see readme.txt";
this.description			= "Ship script for Leviathan Weapons Platform (normal)";
this.version				= "2.31";
"use strict";

this.findTarget = function()
	{
	function isBadGuy(entity) 
		{ 
		return (entity && entity.isValid && entity.isShip && (!entity.scanClass == "CLASS_CARGO") && (entity.isThargoid || entity.isPirate || entity.bounty > 49));
		}

	var targets = system.filteredEntities(this, isBadGuy, this.ship, this.ship.scannerRange);
	if(targets.length > 0)
		{
		this.ship.target = targets[0];
		this.ship.reactToAIMessage("HOSTILE_FOUND");
		}
	}

this.switchAI = function()
	{ this.ship.switchAI("aquatics_platformAI.plist"); }

this.shipDied = function(who,why)
	{
	this.largeCount = (Math.ceil(Math.random() * 4) - 1); // between 0-3 large pieces of wreckage
	this.smallCount = (Math.ceil(Math.random() * 9) - 1); // between 0-8 small pieces of wreckage
	this.fuelCount = (Math.ceil(Math.random() * 30) + 30); // between 31-40 burning fuel entities

	this.ship.spawn("aquatics_burningFuel", this.fuelCount); // spawn the burning fuel

	if(Math.random() > 0.33) //  2 in 3 chance of a piece of non-exploding wreckage
		{ this.ship.spawn("aquatics_survivingWreckage", 1); } // spawn the surviving piece of wreckage

	if(this.largeCount > 0) // if there is large wreckage
		{ this.ship.spawn("aquatics_largeWreckage", this.largeCount); } // spawn the large pieces of exploding wreckage

	if(this.smallCount > 0) // if there is small wreckage
		{ this.ship.spawn("aquatics_smallWreckage", this.smallCount); } // spawn the small pieces of exploding wreckage
	}